/*
 * @Author: 子比主题老唐-Qinver
 * @Url: zibll.com
 * @Date: 2023-10-12 12:18:41
 * @LastEditTime: 2023-10-12 22:32:04
 * @Read me : 本工具为免费开源工具，您可以自由使用和分享，如您需要分享或二次开发，请务必保留并在显眼处体现作者名，以及www.zibll.com的网站
 * @Read me : 不要用于任何商业用途，否则将依法追究相关责任，谢谢合作！
 */

(function ($, document) {
    $(document).ready(function ($) {
        /*global _sql */
        var _wrap = $('.sql-replace-wrap');
        var key_calss_text = 'sql-key';

        //查询数据
        _wrap.on('click', '.sql-next', function () {
            var _this = $(this);
            var old_text = $('.sql-input-old').val();
            var new_text = $('.sql-input-new').val();
            var _submit_btn = $('.sql-submit');

            var data = {
                action: 'sql_replace_next',
                old: old_text,
                new: new_text,
            };

            ajax(_this, data, function (data) {
                var lists = '';
                var all_count = 0;

                if (data.data && data.data.data) {
                    $.each(data.data.data, function (i, lists_data) {
                        var lists_data_count = ~~lists_data.count;
                        if (lists_data_count) {
                            all_count += lists_data_count;
                            lists += '<div>[table_name:' + lists_data.table_name + '] => [column_name:' + lists_data.column_name + '] => count[' + lists_data.count + ']' + (~~lists_data.serialize_count ? ' || serialize_count[' + lists_data.serialize_count + ']' : '') + '</div>';
                        }
                    });
                }

                if (lists) {
                    var notice_html = '<div class="sql-warning">请确认将<span class="' + key_calss_text + ' old">' + data.data.old + '</span>替换为' + '<span class="' + key_calss_text + ' new">' + data.data.new + '</span><div>共计替换' + all_count + '条数据，替换后无法撤回，请确保已备份数据库</div></div>';
                    if (data.data.msg) {
                        notice_html += '<div class="sql-warning">' + data.data.msg + '</div>';
                    }

                    notice_html += '<div><div>替换明细：表 => 列 => 数量 || 序列化数量</div>' + lists + '</div>';

                    notice(notice_html);
                    _this.html('重新查询');
                    _submit_btn.show();
                } else {
                    notice('没有找到匹配的替换内容', 'error');
                    _submit_btn.hide();
                }
            });

            return false;
        });

        //执行替换
        _wrap.on('click', '.sql-submit', function () {
            var _this = $(this);
            var old_text = $('.' + key_calss_text + '.old').text();
            var new_text = $('.' + key_calss_text + '.new').text();

            if (confirm('请再次确认替换【' + old_text + '】为【' + new_text + '】吗？')) {
                return ajax_submit(_this, old_text, new_text);
            }

            return false;
        });

        function ajax_submit(_this, old_text, new_text, auto_submit) {
            if (!old_text || !new_text) {
                return notice('替换参数错误', 'error');
            }

            var ajax_data = {
                action: 'sql_replace_submit',
                old: old_text,
                new: new_text,
            };

            notice('<i class="sql-loading"></i>正在批量替换中，请稍后...', 'info', auto_submit);

            ajax(_this, ajax_data, function (n) {
                var data = n.data;
                var lists = '';

                if (data && data.count) {
                    if (data.data.routine && data.data.routine.detail) {
                        $.each(data.data.routine.detail, function (i, lists_data) {
                            if (~~lists_data.count) {
                                lists += '<div>table_name[' + lists_data.table_name + '] => column_name[' + lists_data.column_name + '] => count[' + lists_data.count + ']</div>';
                            }
                        });
                        if (lists) {
                            lists = '<div><div>数据替换明细：表 => 列 => 数量' + lists;
                        }
                    }

                    if (data.data.serialize && data.data.serialize.detail && ~~data.data.serialize.count) {
                        lists += '<div>序列化数据替换明细：表 => 列 => 数量</div>';
                        $.each(data.data.serialize.detail, function (i, lists_data) {
                            if (~~lists_data.count) {
                                lists += '<div>table_name[' + lists_data.table_name + '] => column_name[' + lists_data.column_name + '] => count[' + lists_data.count + ']</div>';
                            }
                        });
                    }
                }

                if (lists) {
                    var notice_html = '';
                    if (!auto_submit) {
                        notice_html = '<div class="sql-warning">已将<span class="' + key_calss_text + ' old">' + data.old + '</span>替换为' + '<span class="' + key_calss_text + ' new">' + data.new + '</span></div>';
                    }

                    if (data.msg) {
                        notice_html += '<div class="sql-warning">' + data.msg + '</div>';
                    }

                    notice_html += lists;
                    notice(notice_html, 'info', auto_submit);

                    //自动提交
                    if (data.time_over) {
                        ajax_submit(_this, old_text, new_text, true);
                    }
                } else {
                    auto_submit || notice('没有找到匹配的可替换内容', 'error');
                }
            });

            return false;
        }

        function ajax(_this, data, success) {
            if (_this.attr('disabled')) {
                return !1;
            }

            var _text = _this.html();
            data.nonce = _sql.nonce;
            _this.attr('disabled', true).html('<i class="sql-loading"></i>请稍候');

            $.ajax({
                type: 'POST',
                url: _sql.ajax_url,
                data: data,
                dataType: 'json',
                error: function (n) {
                    console.error('ajax请求错误，错误信息如下：', n);
                    _this.attr('disabled', false).html(_text);
                },
                success: function (n) {
                    _this.attr('disabled', false).html(_text); //完成

                    if (!n.success) {
                        $('.sql-submit').hide();
                        return notice(n.data, 'error');
                    }

                    $.isFunction(success) && success(n, _this, data);

                    if (n.reload) {
                        window.location.reload();
                    }
                },
            });
        }

        function notice($msg, type, is_add) {
            var _notice = $('.sql-notice');
            type = type || 'info';
            _notice.removeClass('error success info').addClass(type);
            if (is_add) {
                _notice.append($msg);
            } else {
                _notice.html($msg);
            }
        }

        console.log('数据库批处理工具');
    });
})(jQuery, document);
